'''World of Darkness Mod for Source
Revamp begun on 04/12/08
First copy Started on 11/29/07
By: J3ff Hoogland

Online Storage: http://code.eventscripts.com/39445'''
import es, popuplib, playerlib, random, gamethread, cPickle, os.path

info = es.AddonInfo()
info.name = 'World of Darkness'
info.version = '0.0.2'
info.url = 'http://addons.eventscripts.com/addons/view/worldofdarkness'
info.basename = 'worldofdarkness'
info.author = 'J3ff Hoogland'

#Being Events
#Begin Player Events
def player_spawn(ev):
	userid = int(ev['userid'])
	Player(userid).CheckCharacter()
#End Player Events
#Begin global events
#End global events
#End Events
#Our looping method that handel things such as saving and messaging that the mod is running
def LoopBlock():
	es.msg('#multi', '#green[World of Darkness] #defaultSource Mod is Running.')
	str_path = open(es.getAddonPath('worldofdarkness') + '/Characters.db', 'w')
	cPickle.dump(Characters, str_path)
	str_path.close()
	gamethread.delayed(30, LoopBlock)
#End looping block
#Begin Load Method (And commands)
Players = {}
Characters = {}
def load():
	es.dbgmsg(0, 'Converting your server into a World of Darkness')
	global Characters
	str_path = es.getAddonPath('worldofdarkness') + '/Characters.db'
	if os.path.isfile(str_path):
		file_users = open(str_path)
		Characters = cPickle.load(file_users)
		file_users.close()
	if not es.exists('saycommand', 'wod'):
		es.regsaycmd('wod', 'worldofdarkness/Command')
	if not es.exists('clientcommand', 'wod'):
		es.regclientcmd('wod', 'worldofdarkness/Command')
	ServerVars = {
	'wodMaxXp' : 100
	'wodGame' : 'TF2'
	}
	for x in ServerVars:
		es.ServerVar(x).set(ServerVars[x])
	str_path = es.getAddonPath('worldofdarkness') + '/quests/%s/%s.py'%(es.ServerVar('wodGame'), es.ServerVar('wodGame'))
	if os.path.isfile(str_path):
		es.load(str_path)
	LoopBlock()
	es.dbgmsg(0, 'Coversion finished... A shadow has fallen across your server')
#End Load Method
#Begin Classes
class Player:
	global Players
	def __init__(self, userid):
		self.userid = int(userid)
		self.steamid = es.getplayersteamid(self.userid)
		self.name = es.getplayername(self.userid)
		self.player = playerlib.getPlayer(self.userid)
		if not Players.has_key(self.userid):
			Players[self.userid] = {}
			Players[self.userid]['character'] = None
			Players[self.userid]['pending character'] = None
			Players[self.userid]['characters list'] = []
		self.key = Players[self.userid]
	def CheckCharacter(self):
		for x in Characters:
			if Characters[x]['creator'] == self.steamid:
				if not self.key['character']:
					self.key['character'] = x
				self.key['characters list'].append(x)
		if not self.key['character']:
			Character(self.userid).Setup(self.name, 1)
	def AddCharacter(self, Name):
		self.key['characters list'].append(Name)
		self.key['character'] = Name
	def SetCharacter(self, Name):
		if Characters.has_key(Name):
			if not self.LoopCharacter(Name):
				self.key['character'] = Name
				es.tell(self.userid, '#multi', '#green[World of Darkness] #defaultCharacter changed to #lightgreen%s#default.'%Name)
			else:
				es.tell(self.userid, '#multi', '#green[World of Darkness] #defaultSorry #lightgreen%s #defaultis already loaded by another player.'%Name)
		else:
			es.tell(self.userid, '#multi', '#green[World of Darkness] #defaultSorry #lightgreen%s #defaultwas not found in our character database.'%Name)
	def LoopCharacter(self, Name):
		for x in es.getUseridList():
			if Players[x]['character'] == Name:
				return 1
		return 0
	def TempCharacter(self, Name):
		if Characters.has_key(Name):
			if Characters[Name]['password'] != 'locked':
				self.key['pending character'] = Name
				es.tell(self.userid, '#multi', '#green[World of Darkness] #defaultCharacter #lightgreen%s #defaultPending. Press your Escape Key to finish loading.'%Name)
				es.escinputbox(10, self.userid, '-{ World of Darkness Load Character }-', 'Enter the Password:', 'wod passwordenter')
			else:
				es.tell(self.userid, '#multi', '#green[World of Darkness] #defaultSorry #lightgreen%s #defaultis a locked character.'%Name)
		else:
			es.tell(self.userid, '#multi', '#green[World of Darkness] #defaultSorry #lightgreen%s #defaultwas not found in our character database.'%Name)
	def PasswordEnter(self, Password):
		if self.key['pending character']:
			if Password == Characters[self.key['pending character']]['password']:
				self.SetCharacter(self.key['pending character'])
		else:
			es.tell(self.userid, '#multi', '#green[World of Darkness] #defaultYou do not have a character waiting to be loaded.')
	def CharacterMenu(self):
		CMenu = popuplib.easymenu('CMenu', '_popup_choice', self.CharacterMenuSelect)
		CMenu.settitle('%s\'s Characters:'%self.name)
		for x in self.key['characters list']:
			CMenu.addoption(x, x)
		CMenu.send(self.userid)
	def CharacterMenuSelect(self, userid, choice, popupid):
		es.sexec(self.userid, 'wod load %s'%choice)
class Character:
	global Characters
	def __init__(self, userid=None):
		self.userid = int(userid)
		self.steamid = es.getplayersteamid(self.userid)
		self.character = Players[self.userid]['character']
		self.key = Characters[self.character]
		self.player = playerlib.getPlayer(self.userid)
	def Setup(self, Name, Forced=None):
		if not Characters.has_key(Name):
			if self.player.get('isdead'):
				self.Create(Name)
			elif Forced:
				self.Create(Name)
			else:
				es.tell(self.userid, '#multi', '#green[World of Darkness] #defaultYou must be dead to create a new character.')
		elif Forced:
			try:
				if type(int(Name.split(' ')[len(Name.split(' '))-1])) == int:
					self.Setup('%s %s'%(Name, Name.split(' ')[len(Name.split(' '))-1]+1), 1)
			except:
				self.Setup('%s 2'%Name, 1)
		else:
			es.tell(self.userid, '#multi', '#green[World of Darkness] #defaultSorry #lightgreen%s #defaultis already a character. Please try another.'%Name)
	def Create(self, Name):
		Characters[Name] = {}
		Characters[Name]['creator'] = self.steamid
		Characters[Name]['template'] = 'Mortal'
		Characters[Name]['password'] = 'locked'
		Characters[Name]['xp'] = 0.0
		Characters[Name]['totalxp'] = 0.0
		Characters[Name]['attriutes'] = {'Strength':1, 'Dexterity':1, 'Stamina':1, 'Presence':1}
		Characters[Name]['skills'] = {'Firearms':1, 'Athletics':1, 'Stealth':1, 'Subterfuge':1, 'Larceny':1, 'Occult':1}
		Player(self.userid).AddCharacter(Name)
		es.tell(self.userid, '#multi', '#green[World of Darkness] #lightgreen%s #defaultCreated.'%Name)
	def SetPassword(self, Password):
		Characters[self.character]['password'] = Password
		es.tell(self.userid, '#multi', '#green[World of Darkness] #defaultThis character can now be loaded by anyone this the username and password. Character: #lightgreen%s #defaultPassword: #lightgreen%s'%(self.character, Password))
	def GiveXp(self, amount, reason=None):
		if self.key['totalxp']+amount < int(es.ServerVar('wodMaxXp')):
			self.key['xp'] += amount
			self.key['totalxp'] += amount
			if reason:
				es.tell(self.userid, '#multi', '#green[World of Darkness] #defaultYou have gained #lightgreen%s #defaultXp for %s.'%(amount, reason))
			else:
				es.tell(self.userid, '#multi', '#green[World of Darkness] #defaultYou have gained #lightgreen%s #defaultXp.'%amount)
		else:
			difxp = self.key['totalxp']+amount-int(es.ServerVar('wodMaxXp'))
			self.key['xp'] += amount-difxp
			self.key['totalxp'] += amount-difxp
			if reason:
				es.tell(self.userid, '#multi', '#green[World of Darkness] #defaultYou have gained #lightgreen%s #defaultXp for %s.'%(amount-difxp, reason))
			else:
				es.tell(self.userid, '#multi', '#green[World of Darkness] #defaultYou have gained #lightgreen%s #defaultXp.'%amount-difxp)
#End Classes
#Begin handels for our 'wod' command that can be run in client console/chat
def Command():
	userid = int(es.getcmduserid())
	steamid = es.getplayersteamid(userid)
	arg1 = es.getargv(1).lower()
	argcount = es.getargc()
	stringcount = 2
	commandstring = ''
	while stringcount < argcount:
		addstring = es.getargv(stringcount)
		if commandstring:
			commandstring = '%s %s'%(commandstring, addstring)
		else:
			commandstring = addstring
		stringcount += 1
	if arg1 == 'create':
		Character(userid).Setup(commandstring)
	elif arg1 == 'load':
		if playerlib.getPlayer(userid).get('isdead'):
			if Characters.has_key(commandstring):
				if Characters[commandstring]['password'] == 'locked' and Characters[commandstring]['creator'] == steamid:
					Player(userid).SetCharacter(commandstring)
				else:
					Player(userid).TempCharacter(commandstring)
			else:
				es.tell(userid, '#multi', '#green[World of Darkness] #defaultSorry #lightgreen%s #defaultwas not found in our character database.'%Name)
	elif arg1 == 'passwordenter':
		Player(userid).PasswordEnter(commandstring)
	elif arg1 == 'passwordset':
		Character(userid).SetPassword(commandstring)
	elif arg1 == 'loadmenu':
		Player(userid).CharacterMenu()
	else:
		es.tell(userid, '#multi', '#green[World of Darkness] #defaultSorry #lightgreen%s #default is not a valid command.'%commandstring)
#End our command handels